<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" @ok="handleSubmit" :closeFunc="handlerCloseFunc" >
    <template #footer>
        <a-button v-show="!isDetail && (pFlag || isUpdate)" key="back" @click="handleCancel">取消</a-button>
        <a-button v-show="pFlag" key="submit" type="primary" @click="handleNext">下一步</a-button>
        <a-button v-show="!pFlag && !isUpdate" key="back" @click="handleUpper">上一步</a-button>
        <a-button v-show="!isDetail && !pFlag" key="submit" type="primary" @click="handleSubmit">确定</a-button>
      </template>  
    <ActSelect v-show="pFlag" :actinfo="actinfo" :isFilte="true" bizType="hg" :bizNo="bizeNo" />
    <BasicForm v-show="!pFlag" @register="registerForm"/>
  </BasicModal>
</template>

<script lang="ts" setup>
import { message } from 'ant-design-vue';
import { computed, ref, unref } from 'vue';
import ActSelect from '../../components/ActSelect.vue';
import { saveOrUpdate } from '../StComplianeItem.api';
import { formSchema } from '../StComplianeItem.data';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BasicModal, useModalInner } from '/@/components/Modal';
    const pFlag = ref(true)
    const actinfo = ref({})
    // Emits声明
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);
    const isDetail = ref(false);
    const bizeNo = ref('')
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        isDetail.value = !data?.showFooter
        bizeNo.value = data?.complianeNo

        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
          // 改变pFlag状态
          pFlag.value = false
        }else{
            pFlag.value = true
            setFieldsValue({
                complianeNo: data?.complianeNo,
            }); 
        }
        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    const title = computed(() => (pFlag.value?'选择控制活动':!unref(isUpdate) ? '填写内容' : (unref(isDetail)?'查看内容':'修改内容')));
    function handlerCloseFunc(){
        pFlag.value = true
        if(actinfo.value.caNo){
            actinfo.value = {}
        }
        return new Promise((res,rej)=>{res(true)})
    }
    function handleUpper() {
        pFlag.value = true
    }
    function handleNext() {
        console.log(actinfo)
        if(!actinfo.value.caNo){
            message.warn("请选择控制活动！")
            return
        }
        pFlag.value = false
        actinfo.value.id = ''
        setFieldsValue({
            ...actinfo.value,
        });
    }
    function handleCancel() {
        if(actinfo.value.caNo){
            actinfo.value = {}
        }
        closeModal()
    }
    //表单提交事件
    async function handleSubmit(v) {
        try {
            let values = await validate();
            setModalProps({confirmLoading: true});
            //提交表单
            await saveOrUpdate(values, isUpdate.value);
            //关闭弹窗
            closeModal();
            //刷新列表
            emit('success');
        } finally {
            setModalProps({confirmLoading: false});
        }
    }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>